=== modified file 'Makefile'
--- Makefile	2009-02-25 01:31:13 +0000
+++ Makefile	2009-05-17 01:04:29 +0000
@@ -16,7 +16,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.8
+version=1.0.9
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2009-02-25 01:31:13 +0000
+++ NEWS	2009-05-17 01:04:29 +0000
@@ -1,6 +1,12 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.0.9 (2009-05-17)
+* Client
+** Security bug fix: Fix permissions on initrd.img file when
+   installing new linux-image-* packages calling mkinitramfs-kpkg (all
+   version lower than 2.6.28-1-* does this).
+
 Version 1.0.8 (2009-02-25)
 * Client
 ** Bug fix: Fix missing quote characters in initramfs-tools-hook.

=== modified file 'common.ent'
--- common.ent	2009-02-25 01:31:13 +0000
+++ common.ent	2009-05-17 01:04:29 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.0.8">
+<!ENTITY version "1.0.9">

=== modified file 'debian/changelog'
--- debian/changelog	2009-02-25 01:31:13 +0000
+++ debian/changelog	2009-05-17 01:04:29 +0000
@@ -1,3 +1,9 @@
+mandos (1.0.9-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 17 May 2009 02:59:45 +0200
+
 mandos (1.0.8-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2009-03-11 01:06:17 +0000
+++ initramfs-tools-hook	2009-02-25 01:14:29 +0000
@@ -92,7 +92,7 @@
     fi
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
-	*/"*") echo "W: Mandos client plugin directory is empty." >&2 ;;
+	"*") : ;;
 	*) copy_exec "$file" "${PLUGINDIR}" ;;
     esac
 done
@@ -102,7 +102,7 @@
     base="`basename \"$file\"`"
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
-	*/"*") : ;;
+	"*") : ;;
 	*) copy_exec "$file" "${PLUGINDIR}" ;;
     esac
 done

=== modified file 'initramfs-tools-hook-conf'
--- initramfs-tools-hook-conf	2008-08-12 19:22:34 +0000
+++ initramfs-tools-hook-conf	2009-05-17 00:50:09 +0000
@@ -1,1 +1,13 @@
+# -*- shell-script -*-
+
+# if mkinitramfs is started by mkinitramfs-kpkg, mkinitramfs-kpkg has
+# already touched the initrd file with umask 022 before we had a
+# chance to affect it.  We cannot allow a readable initrd file,
+# therefore we must fix this now.
+if [ -e "${outfile}" ] \
+    && [ `stat --format=%s "${outfile}"` -eq 0 ]; then
+    rm "${outfile}"
+    (umask 027; touch "${outfile}")
+fi
+
 UMASK=027

=== modified file 'mandos'
--- mandos	2009-03-15 04:22:14 +0000
+++ mandos	2009-05-17 01:04:29 +0000
@@ -66,7 +66,7 @@
 import ctypes
 import ctypes.util
 
-version = "1.0.8"
+version = "1.0.9"
 
 logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
@@ -678,107 +678,80 @@
     def handle(self):
         logger.info(u"TCP connection from: %s",
                     unicode(self.client_address))
-        logger.debug(u"Pipe: %d", self.server.pipe[1])
-        # Open IPC pipe to parent process
-        with closing(os.fdopen(self.server.pipe[1], "w", 1)) as ipc:
-            session = (gnutls.connection
-                       .ClientSession(self.request,
-                                      gnutls.connection
-                                      .X509Credentials()))
-            
-            line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
-            try:
-                if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
-                return
-            
-            # Note: gnutls.connection.X509Credentials is really a
-            # generic GnuTLS certificate credentials object so long as
-            # no X.509 keys are added to it.  Therefore, we can use it
-            # here despite using OpenPGP certificates.
-            
-            #priority = ':'.join(("NONE", "+VERS-TLS1.1",
-            #                     "+AES-256-CBC", "+SHA1",
-            #                     "+COMP-NULL", "+CTYPE-OPENPGP",
-            #                     "+DHE-DSS"))
-            # Use a fallback default, since this MUST be set.
-            priority = self.server.settings.get("priority", "NORMAL")
-            (gnutls.library.functions
-             .gnutls_priority_set_direct(session._c_object,
-                                         priority, None))
-            
-            try:
-                session.handshake()
-            except gnutls.errors.GNUTLSError, error:
-                logger.warning(u"Handshake failed: %s", error)
-                # Do not run session.bye() here: the session is not
-                # established.  Just abandon the request.
-                return
-            logger.debug(u"Handshake succeeded")
-            try:
-                fpr = fingerprint(peer_certificate(session))
-            except (TypeError, gnutls.errors.GNUTLSError), error:
-                logger.warning(u"Bad certificate: %s", error)
-                session.bye()
-                return
-            logger.debug(u"Fingerprint: %s", fpr)
-            
-            for c in self.server.clients:
-                if c.fingerprint == fpr:
-                    client = c
-                    break
-            else:
-                logger.warning(u"Client not found for fingerprint: %s",
-                               fpr)
-                ipc.write("NOTFOUND %s\n" % fpr)
-                session.bye()
-                return
-            # Have to check if client.still_valid(), since it is
-            # possible that the client timed out while establishing
-            # the GnuTLS session.
-            if not client.still_valid():
-                logger.warning(u"Client %(name)s is invalid",
-                               vars(client))
-                ipc.write("INVALID %s\n" % client.name)
-                session.bye()
-                return
-            ipc.write("SENDING %s\n" % client.name)
-            sent_size = 0
-            while sent_size < len(client.secret):
-                sent = session.send(client.secret[sent_size:])
-                logger.debug(u"Sent: %d, remaining: %d",
-                             sent, len(client.secret)
-                             - (sent_size + sent))
-                sent_size += sent
-            session.bye()
-
-
-class ForkingMixInWithPipe(SocketServer.ForkingMixIn, object):
-    """Like SocketServer.ForkingMixIn, but also pass a pipe.
-    Assumes a gobject.MainLoop event loop.
-    """
-    def process_request(self, request, client_address):
-        """This overrides and wraps the original process_request().
-        This function creates a new pipe in self.pipe 
-        """
-        self.pipe = os.pipe()
-        super(ForkingMixInWithPipe,
-              self).process_request(request, client_address)
-        os.close(self.pipe[1])  # close write end
-        # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(self.pipe[0],
-                             gobject.IO_IN | gobject.IO_HUP,
-                             self.handle_ipc)
-    def handle_ipc(source, condition):
-        """Dummy function; override as necessary"""
-        os.close(source)
-        return False
-
-
-class IPv6_TCPServer(ForkingMixInWithPipe,
+        session = (gnutls.connection
+                   .ClientSession(self.request,
+                                  gnutls.connection
+                                  .X509Credentials()))
+        
+        line = self.request.makefile().readline()
+        logger.debug(u"Protocol version: %r", line)
+        try:
+            if int(line.strip().split()[0]) > 1:
+                raise RuntimeError
+        except (ValueError, IndexError, RuntimeError), error:
+            logger.error(u"Unknown protocol version: %s", error)
+            return
+        
+        # Note: gnutls.connection.X509Credentials is really a generic
+        # GnuTLS certificate credentials object so long as no X.509
+        # keys are added to it.  Therefore, we can use it here despite
+        # using OpenPGP certificates.
+        
+        #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
+        #                     "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
+        #                     "+DHE-DSS"))
+        # Use a fallback default, since this MUST be set.
+        priority = self.server.settings.get("priority", "NORMAL")
+        (gnutls.library.functions
+         .gnutls_priority_set_direct(session._c_object,
+                                     priority, None))
+        
+        try:
+            session.handshake()
+        except gnutls.errors.GNUTLSError, error:
+            logger.warning(u"Handshake failed: %s", error)
+            # Do not run session.bye() here: the session is not
+            # established.  Just abandon the request.
+            return
+        logger.debug(u"Handshake succeeded")
+        try:
+            fpr = fingerprint(peer_certificate(session))
+        except (TypeError, gnutls.errors.GNUTLSError), error:
+            logger.warning(u"Bad certificate: %s", error)
+            session.bye()
+            return
+        logger.debug(u"Fingerprint: %s", fpr)
+        
+        for c in self.server.clients:
+            if c.fingerprint == fpr:
+                client = c
+                break
+        else:
+            logger.warning(u"Client not found for fingerprint: %s",
+                           fpr)
+            session.bye()
+            return
+        # Have to check if client.still_valid(), since it is possible
+        # that the client timed out while establishing the GnuTLS
+        # session.
+        if not client.still_valid():
+            logger.warning(u"Client %(name)s is invalid",
+                           vars(client))
+            session.bye()
+            return
+        ## This won't work here, since we're in a fork.
+        # client.checked_ok()
+        sent_size = 0
+        while sent_size < len(client.secret):
+            sent = session.send(client.secret[sent_size:])
+            logger.debug(u"Sent: %d, remaining: %d",
+                         sent, len(client.secret)
+                         - (sent_size + sent))
+            sent_size += sent
+        session.bye()
+
+
+class IPv6_TCPServer(SocketServer.ForkingMixIn,
                      SocketServer.TCPServer, object):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
     Attributes:
@@ -843,40 +816,6 @@
             return super(IPv6_TCPServer, self).server_activate()
     def enable(self):
         self.enabled = True
-    def handle_ipc(self, source, condition, file_objects={}):
-        logger.debug("Handling IPC: %r : %r", source, condition)
-        
-        # Turn a file descriptor into a Python file object
-        if source not in file_objects:
-            file_objects[source] = os.fdopen(source, "r", 1)
-        
-        # Read a line from the file object
-        cmdline = file_objects[source].readline()
-        if not cmdline:             # Empty line means end of file
-            # close the IPC pipe
-            logger.debug("Closing: %r", source)
-            file_objects[source].close()
-            del file_objects[source]
-
-            # Stop calling this function
-            return False
-        
-        logger.debug("IPC command: %r\n" % cmdline)
-        
-        # Parse and act on command
-        cmd, args = cmdline.split(None, 1)
-        if cmd == "NOTFOUND":
-            pass                # xxx
-        elif cmd == "INVALID":
-            pass                # xxx
-        elif cmd == "SENDING":
-            pass                # xxx
-            # client.checked_ok()
-        else:
-            logger.error("Unknown IPC command: %r", cmdline)
-        
-        # Keep calling this function
-        return True
 
 
 def string_to_delta(interval):
@@ -1010,8 +949,7 @@
                       " files")
     parser.add_option("--no-dbus", action="store_false",
                       dest="use_dbus",
-                      help="Do not provide D-Bus system bus"
-                      " interface")
+                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
     parser.add_option("--no-ipv6", action="store_false",
                       dest="use_ipv6", help="Do not use IPv6")
     options = parser.parse_args()[0]
@@ -1065,6 +1003,7 @@
     # For convenience
     debug = server_settings["debug"]
     use_dbus = server_settings["use_dbus"]
+    use_dbus = False            # XXX: Not done yet
     use_ipv6 = server_settings["use_ipv6"]
     
     if not debug:

=== modified file 'mandos-ctl'
--- mandos-ctl	2009-02-25 01:31:13 +0000
+++ mandos-ctl	2009-05-17 01:04:29 +0000
@@ -31,7 +31,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.0.8"
+version = "1.0.9"
 bus = dbus.SystemBus()
 mandos_dbus_objc = bus.get_object(busname, server_path)
 mandos_serv = dbus.Interface(mandos_dbus_objc,

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-02-25 01:31:13 +0000
+++ mandos-keygen	2009-05-17 01:04:29 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.8"
+VERSION="1.0.9"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-02-25 01:31:13 +0000
+++ mandos.lsm	2009-05-17 01:04:29 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.8
-Entered-date:	2009-02-25
+Version:	1.0.9
+Entered-date:	2009-05-17
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      98K mandos_1.0.8.orig.tar.gz
+	      99K mandos_1.0.9.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		98K mandos_1.0.8.orig.tar.gz
+		99K mandos_1.0.9.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2009-02-25 01:47:45 +0000
+++ mandos.xml	2009-02-25 01:21:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2009-02-15">
+<!ENTITY TIMESTAMP "2009-02-24">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -86,8 +86,6 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
-      <arg><option>--no-dbus</option></arg>
-      <sbr/>
       <arg><option>--no-ipv6</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -235,16 +233,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--no-dbus</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
-	  <para>
-	    See also <xref linkend="dbus_interface"/>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--no-ipv6</option></term>
 	<listitem>
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
@@ -345,16 +333,6 @@
     </para>
   </refsect1>
   
-  <refsect1 id="dbus_interface">
-    <title>D-BUS INTERFACE</title>
-    <para>
-      The server will by default provide a D-Bus system bus interface.
-      This interface will only be accessible by the root user or a
-      Mandos-specific user, if such a user exists.
-      <!-- XXX -->
-    </para>
-  </refsect1>
-  
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-02-25 12:20:01 +0000
+++ plugins.d/mandos-client.c	2009-02-14 18:07:05 +0000
@@ -566,7 +566,7 @@
   
   memset(&to, 0, sizeof(to));
   if(af == AF_INET6){
-    to.in6.sin6_family = (sa_family_t)af;
+    to.in6.sin6_family = (uint16_t)af;
     ret = inet_pton(af, ip, &to.in6.sin6_addr);
   } else {			/* IPv4 */
     to.in.sin_family = (sa_family_t)af;

